; fxMacs.INC                                                                 ;
; Copyright (c) Genus Microprogramming, Inc. 1988-89  All Rights Reserved.   ;

;****************************************************************************;
;                                                                            ;
; This file contains defines and macros for DOS and BIOS interfacing.        ;
;                                                                            ;
;                                                                            ;
;                                                                            ;
;                                                                            ;
;                                                                            ;
;                                                                            ;
; Microsoft ASM 5.x version.              Programmer: Chris Howard  3/15/89  ;
;                                                                            ;
;****************************************************************************;


;Interrupts
INT_CLOCK equ       1AH                     ;Clock services
INT_TIMER equ       1CH                     ;Timer interrupt

; Clock
READCLOCK equ       00H                     ;Read the current clock count
SETCLOCK  equ       01H                     ;Set the current clock count

; Sound Chip
PPIPORT   equ       61H                     ;PPI chip port
PPIBITS   equ       00000011B               ;Bits 0 and 1 turn on speaker
TIMERPORT equ       43H                     ;Signal timer
COUNTRDY  equ       0B6H                    ;Count is ready signal
FREQPORT  equ       42H                     ;Load frequency
COUNTHI   equ       0012H                   ;Maximum timer count high
COUNTLO   equ       3540H                   ; and low words

@CLOCK    MACRO     func                    ;;Macro to use DOS function calls
          mov       ah,func
          int       INT_CLOCK
          ENDM

@InitFX   MACRO     type,fx    
          mov       ax,type                 ;;Macro to initialize a display
          push      ax                      ;; function pointer
          call      fxGetEffectStruc
          mov       bx,ax                   ;;Calc structure offset
          mov       BYTE PTR [bx].fxtype,  type
          mov       WORD PTR [bx].fxfunc,  OFFSET fx    
          mov       WORD PTR [bx].fxfunc+2,SEG    fx    
          ENDM
